// REAL

#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspctrl.h>
#include "graphics.h"

#define RGB(r, g, b) ((r)|((g)<<8)|((b)<<16))

void Game()
{    
 SceCtrlData pad;

 int LinkJump = 0; 

 int movespeed = 2;
 float maxspeed = 5;
 float xspeed, yspeed, friction;
 xspeed = yspeed = 0.0f;
 friction = .98f;

 int LinkHealth = 100;
 int LinkEnergy = 100;

 int Counter = 0;

 int LinkPosY = 145;
 int LinkPosX = -37;
 int LinkFrameCounter = 44;

 int WidthPos = 50;
 Color White = RGB(255, 255, 255);

 int LinkSwing = 0;
 
 int d; 
 int LinkLevel = 1; 

 int onGround = 1;
 
 #define printf pspDebugScreenPrintf
 #define RGB(r, g, b) ((r)|((g)<<8)|((b)<<16))
 

 Image* Level1;
 Level1 = loadImage("./Images/Level1/1-1.png");
 
 char text[10];

 Image* Status[3];
 Status[0] = loadImage("./Images/Status/health.png");
 Status[1] = loadImage("./Images/Status/energy.png");
 Status[2] = loadImage("./Images/Status/infobox.png");

 Image* Link[119];
 
 Link[0] = loadImage("./Images/Link/LinkWalking1Backwards.png");
 Link[1] = Link[0];
 Link[2] = Link[0];
 Link[3] = Link[0];

 
 Link[4] = loadImage("./Images/Link/LinkWalking2Backwards.png");
 Link[5] = Link[4];
 Link[6] = Link[4];
 Link[7] = Link[4];

 
 Link[8] = loadImage("./Images/Link/LinkWalking3Backwards.png");
 Link[9] = Link[8];
 Link[10] = Link[8];
 Link[11] = Link[8];

 
 Link[12] = loadImage("./Images/Link/LinkWalking4Backwards.png");
 Link[13] = Link[12];
 Link[14] = Link[12];
 Link[15] = Link[12];
 
 
 Link[16] = loadImage("./Images/Link/LinkWalking5Backwards.png");
 Link[17] = Link[16];
 Link[18] = Link[16];
 Link[19] = Link[16];

 
 Link[20] = loadImage("./Images/Link/LinkWalking6Backwards.png");
 Link[21] = Link[20];
 Link[22] = Link[20];
 Link[23] = Link[20];

 
 Link[24] = loadImage("./Images/Link/LinkWalking5Backwards.png");
 Link[25] = Link[24];
 Link[26] = Link[24];
 Link[27] = Link[24];

 
 Link[28] = loadImage("./Images/Link/LinkWalking4Backwards.png");
 Link[29] = Link[28];
 Link[30] = Link[28];
 Link[31] = Link[28];

 
 Link[32] = loadImage("./Images/Link/LinkWalking3Backwards.png");
 Link[33] = Link[32];
 Link[34] = Link[32];
 Link[35] = Link[32];
 
 Link[36] = loadImage("./Images/Link/LinkWalking2Backwards.png");
 Link[37] = Link[36];
 Link[38] = Link[36];
 Link[39] = Link[36];
   
 Link[40] = loadImage("./Images/Link/LinkWalking1Backwards.png");
 Link[41] = Link[40];
 Link[42] = Link[40];
 Link[43] = Link[40];

 
 Link[44] = loadImage("./Images/Link/LinkWalking1.png");
 Link[45] = Link[44];
 Link[46] = Link[44];
 Link[47] = Link[44];

 Link[48] = loadImage("./Images/Link/LinkWalking2.png");
 Link[49] = Link[48];
 Link[50] = Link[48];
 Link[51] = Link[48];
 
 Link[52] = loadImage("./Images/Link/LinkWalking3.png");
 Link[53] = Link[52];
 Link[54] = Link[52];
 Link[55] = Link[52];


 Link[56] = loadImage("./Images/Link/LinkWalking4.png");
 Link[57] = Link[56];
 Link[58] = Link[56];
 Link[59] = Link[56];

 
 Link[60] = loadImage("./Images/Link/LinkWalking5.png");
 Link[61] = Link[60];
 Link[62] = Link[60];
 Link[63] = Link[60];

 
 Link[64] = loadImage("./Images/Link/LinkWalking6.png");
 Link[65] = Link[64];
 Link[66] = Link[64];
 Link[67] = Link[64];

 
 Link[68] = loadImage("./Images/Link/LinkWalking7.png");
 Link[69] = Link[68];
 Link[70] = Link[68];
 Link[71] = Link[68];

 
 Link[72] = Link[64];
 Link[73] = Link[72];
 Link[74] = Link[72];
 Link[75] = Link[72];
 
 
 Link[76] = Link[56];
 Link[77] = Link[76];
 Link[78] = Link[76];
 Link[79] = Link[76];
 
 
 Link[80] = Link[52];
 Link[81] = Link[80];
 Link[82] = Link[80];
 Link[83] = Link[80];
 
 Link[84] = Link[48];
 Link[85] = Link[84];
 Link[86] = Link[84];
 Link[87] = Link[84];
 
 Link[88] = loadImage("./Images/Link/LinkAttack-Side1.png");
 Link[89] = Link[88];
 Link[90] = Link[88];
 Link[91] = Link[88];
 
 Link[92] = loadImage("./Images/Link/LinkAttack-Side2.png");
 Link[93] = Link[92];
 Link[94] = Link[92];
 Link[95] = Link[92];
 
 Link[96] = loadImage("./Images/Link/LinkAttack-Side3.png");
 Link[97] = Link[96];
 Link[98] = Link[96];
 Link[99] = Link[96];
 Link[100] = Link[96];
 Link[101] = Link[96];
 Link[102] = Link[96];
 
 
 Link[103] = loadImage("./Images/Link/LinkAttack-Side4.png");
 Link[104] = Link[100];
 Link[105] = Link[100];
 Link[106] = Link[100];
 
 Link[107] = Link[96];
 Link[108] = Link[96];
 Link[109] = Link[96];
 Link[110] = Link[96];
 
 Link[111] = Link[92];
 Link[112] = Link[92];
 Link[113] = Link[92];
 Link[114] = Link[92];
 
 Link[115] = Link[88];
 Link[116] = Link[88];
 Link[117] = Link[88];
 Link[118] = Link[88];

 
 
 while(1)
 {
 sceCtrlReadBufferPositive(&pad, 1);

// 40 is normal
 if (pad.Buttons & PSP_CTRL_LEFT)
      {
      LinkPosX -= 2;
      if (LinkFrameCounter >= 44)
      {
                           LinkFrameCounter = 43;
                           LinkFrameCounter--;
      }
      else 
      {
      LinkFrameCounter--;
      }
      if (LinkFrameCounter < 4)
      {
                           LinkFrameCounter = 39;
      }
      }



 if (pad.Buttons & PSP_CTRL_RIGHT)
      {
      LinkPosX += 2;
      if (LinkFrameCounter <= 43)
      {
                           LinkFrameCounter = 48;
                           LinkFrameCounter++;
      }
      else 
      {
      LinkFrameCounter++;
      }    
      if (LinkFrameCounter > 87)
      {
                           LinkFrameCounter = 48;
      }
      }
      
 // NOTE! For LinkSwing:
 // 0 is off
 // 1 is on
 
 // It cannot go past 2.
      
 /*
 How LinkSwing Works:
     When LinkSwing is on 1, LinkFrameCounter goes up.
     Once he is done with his sword animation, LinkFrameCounter resets, 
     and LinkSwing turns off. (0).
 */     
 if (pad.Buttons & PSP_CTRL_CROSS)
      {               
                LinkSwing += 1;
                if (LinkSwing >= 2)
                {
                              LinkSwing = 1;
                }  
      }       
      
 if (LinkSwing == 1)
     { 
               if (LinkFrameCounter <= 87)
               {
                                    LinkFrameCounter = 88;
               }
               LinkFrameCounter++;
               if (LinkFrameCounter > 118)
               {
                                    LinkFrameCounter = 88;
                                    LinkSwing = 0;
               }
    }              
    
       
               if (pad.Buttons & PSP_CTRL_CIRCLE)
               {                 
                                 yspeed += (float)movespeed;                               
               }

               if(yspeed > maxspeed){yspeed = maxspeed;}
               if(yspeed < -maxspeed){yspeed = -maxspeed;}
               yspeed -= friction;

LinkPosY -= yspeed;

               
               if (LinkPosY < -50)
               {
                            LinkPosY = -50;
               }
               
               if (LinkPosY > 145)
               {
                            LinkPosY = 145;
               }
  
 if (LinkPosX < -37)
    {
      LinkPosX = -37;
    }
 
 if (LinkPosX > 420)
    {
     LinkPosX = 420;
    }

 blitAlphaImageToScreen(0, 0, 480, 272, Level1, 0, 0);
  
 blitAlphaImageToScreen(0 , 0, 200, 100, Status[2], 0, 0);
 
 blitAlphaImageToScreen(0 , 0, LinkHealth, 30, Status[0], 0, 2);
 blitAlphaImageToScreen(0 , 0, LinkEnergy, 30, Status[1], 0, 32);
 
 sprintf(text, "%d", LinkLevel);
 printTextScreen(22, 66, text, RGB(255, 255, 255));
 
 blitAlphaImageToScreen(0, 0, 100, 100, Link[LinkFrameCounter], LinkPosX, LinkPosY);

 sceDisplayWaitVblankStart();
 flipScreen();

 }
 freeImage(Link[0]);
 freeImage(Link[4]);
 freeImage(Link[8]);
 freeImage(Link[12]);
 freeImage(Link[16]);
 freeImage(Link[20]);
 freeImage(Link[24]);
 freeImage(Link[28]);
 freeImage(Link[32]);
 freeImage(Link[36]);
 freeImage(Link[40]);
 freeImage(Link[44]);
 freeImage(Link[48]);
 freeImage(Link[52]);
 freeImage(Link[56]);
 freeImage(Link[60]);
 freeImage(Link[64]);
 freeImage(Link[68]);
 freeImage(Link[72]);
 freeImage(Link[76]);
 freeImage(Link[80]);    
 freeImage(Link[84]);
 }
