#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspctrl.h>
#include <stdio.h> //ADDITION FOR SPRINTF
#include </usr/include/sys/stat.h> //ADDITION FOR TIME
#include "graphics.h"
#include "credits.h"
#include "game.h"

#define RGB(r, g, b) ((r)|((g)<<8)|((b)<<16))

void Menu()
{
 SceCtrlData pad, lastpad;
 sceCtrlReadBufferPositive(&lastpad, 1);

 Color White = RGB(255, 255, 255);
 

 Image* MenuImages[3];
 MenuImages[0] = loadImage("./Images/Menu/menu0.png");
 MenuImages[1] = loadImage("./Images/Menu/menu1.png");
 MenuImages[2] = loadImage("./Images/Menu/menu2.png");
 
 Image* CreditImage[1];
 CreditImage[1] = loadImage("./Images/Menu/credits.png");

 int FrameCounter = 0;

 extern int PressedCrossButton;
 int MenuOne = 0;
 
 while(1)
 {
 sceCtrlReadBufferPositive(&pad, 1);
 
 if(pad.Buttons != lastpad.Buttons) {
 lastpad = pad;


   if (pad.Buttons & PSP_CTRL_UP)
       {               
       FrameCounter --;
       if (FrameCounter < 0) 
         FrameCounter = 0;
       }
 

 if (pad.Buttons & PSP_CTRL_DOWN)
      {
      FrameCounter ++;
      if (FrameCounter > 2)
         FrameCounter = 2;
      }
      
   if (pad.Buttons & PSP_CTRL_CROSS)
   {
                   if (FrameCounter == 0)
                   {
                                    Game();
                   }
                   
                   if (FrameCounter == 1)
                   {
                                   Credits();
                   }
                   
                   else if (FrameCounter == 2)
                   {
                                    sceKernelExitGame();
                   }                
                                         
   }               
    
 fillScreenRect(White, 0, 0, 480, 272);
 blitAlphaImageToScreen(0, 0, 480, 272, MenuImages[FrameCounter], 0, 0);
 

 sceDisplayWaitVblankStart();
 flipScreen();
}
}
}

